<template>
  <div id="id-map"></div>
</template>

<script>
import "ol/ol.css";

import Feature from "ol/Feature";
import Map from "ol/Map";
import Point from "ol/geom/Point";
import View from "ol/View";
import { Icon, Style, Circle, Stroke, Fill } from "ol/style";
import { Modify } from "ol/interaction";
import { OSM, Vector as VectorSource } from "ol/source";
import { Tile as TileLayer, Vector as VectorLayer } from "ol/layer";

import { toLonLat, fromLonLat } from "ol/proj";
import { mapGetters } from "vuex";
export default {
  name: "MAP-MH",
  data: () => ({
    point: [],
    source: null
  }),
  computed: {
    ...mapGetters(["getPoints"])
  },
  watch: {
    getPoints: function() {
      this.source.clear();
      this.point = [];
      this.getPoints.forEach(el => {
        this.point[el.id] = new Feature({
          geometry: new Point(fromLonLat([el.longitude, el.latitude]))
        });
        this.source.addFeature(this.point[el.id]);
      });
    }
  },

  mounted() {
    let raster = new TileLayer({
      source: new OSM()
    });

    let source = new VectorSource({});
    this.source = source;
    let vector = new VectorLayer({
      source: source
    });

    const map = new Map({
      target: "id-map",
      layers: [raster, vector],
      view: new View({
        center: [0, 0],
        zoom: 0
      })
    });
    let modify = new Modify({
      hitDetection: vector,
      source: source
    });
    modify.on(["modifyend"], evt => {
      let i = 0;
      let id = this.point.findIndex(el => el === evt.features.getArray()[0]);
      let [longitude, latitude] = toLonLat(
        evt.features
          .getArray()[0]
          .getGeometry()
          .getCoordinates()
      );

      let payload = {
        id,
        longitude: longitude.toFixed(5),
        latitude: latitude.toFixed(5)
      };

      this.$emit("setPoint", payload);
    });

    map.addInteraction(modify);
    map.on("contextmenu", e => {
      e.preventDefault();
      source.clear();
      this.point = [];
      this.$emit("clearPoint");
    });
    map.on("click", evt => {
      let [longitude, latitude] = toLonLat(evt.coordinate);
      let pointcount = this.point.length;
      if (pointcount < 6) {
        let payload = {
          id: this.point.length,
          longitude: longitude.toFixed(5),
          latitude: latitude.toFixed(5)
        };

        this.$emit("newPoint", payload);

        this.point[pointcount] = new Feature({
          geometry: new Point(fromLonLat([longitude, latitude]))
        });
        this.point[pointcount].setId(pointcount);
        source.addFeature(this.point[pointcount]);
      }
    });
  }
};
</script>
<style scoped>
#id-map {
  width: 100%;
  height: 100%;
}
</style>
